using System;
using System.Windows.Forms;
using System.Drawing;
using System.Runtime.InteropServices;

 
namespace UserPropertyInMail
{
    /// <summary>
    /// Summary description for ADXOlForm1.
    /// </summary>
    public class ADXOlForm1 : AddinExpress.OL.ADXOlForm
    { 
        private System.ComponentModel.IContainer components = null;
 
 	     public ADXOlForm1()
 	     {
            // This call is required by the Windows Form Designer.
            InitializeComponent();
 
            // TODO: Add any initialization after the InitializeComponent call
 
        }
 
        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if(components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }
 
        #region Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.laUserPropertyName = new System.Windows.Forms.Label();
            this.tbCustomUserProperty = new System.Windows.Forms.TextBox();
            this.SuspendLayout();
            // 
            // laUserPropertyName
            // 
            this.laUserPropertyName.AutoSize = true;
            this.laUserPropertyName.Location = new System.Drawing.Point(15, 9);
            this.laUserPropertyName.Name = "laUserPropertyName";
            this.laUserPropertyName.Size = new System.Drawing.Size(109, 13);
            this.laUserPropertyName.TabIndex = 3;
            this.laUserPropertyName.Text = "Custom User Property";
            // 
            // tbCustomUserProperty
            // 
            this.tbCustomUserProperty.Location = new System.Drawing.Point(18, 36);
            this.tbCustomUserProperty.Name = "tbCustomUserProperty";
            this.tbCustomUserProperty.Size = new System.Drawing.Size(173, 20);
            this.tbCustomUserProperty.TabIndex = 2;
            this.tbCustomUserProperty.TextChanged += new System.EventHandler(this.tbCustomUserProperty_TextChanged);
            // 
            // ADXOlForm1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(218, 106);
            this.Controls.Add(this.laUserPropertyName);
            this.Controls.Add(this.tbCustomUserProperty);
            this.Name = "ADXOlForm1";
            this.Text = "ADXOlForm1";
            this.ADXBeforeInspectorSubpaneClose += new AddinExpress.OL.ADXOlForm.BeforeInspectorSubpaneClose_EventHandler(this.ADXOlForm1_ADXBeforeInspectorSubpaneClose);
            this.VisibleChanged += new System.EventHandler(this.ADXOlForm1_VisibleChanged);
            this.ADXBeforeFormShow += new AddinExpress.OL.ADXOlForm.BeforeFormShow_EventHandler(this.ADXOlForm1_ADXBeforeFormShow);
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        private Label laUserPropertyName;
        private TextBox tbCustomUserProperty;

        private Outlook.MailItem _mailItem = null;

        public Outlook.MailItem MailItem
        {
            get
            {
                if (_mailItem == null)
                {
                    if (this.InspectorObj != null)
                    {
                        _mailItem = (InspectorObj as Outlook.Inspector).CurrentItem as Outlook.MailItem;
                    }
                }
                return _mailItem;
            }
        }

        public string CustomUserProperty
        {
            get
            {
                return tbCustomUserProperty.Text;
            }
        }

        private void SaveCustomUserPropertyToItem()
        {
            Outlook.UserProperty userProperty = MailItem.UserProperties.Find(this.UserProperty, true);
            if (userProperty == null)
            {
                userProperty = MailItem.UserProperties.Add(this.UserProperty, Outlook.OlUserPropertyType.olText, true, Type.Missing);
            }

            if (userProperty != null)
            {
                userProperty.Value = CustomUserProperty;
            }
        }

        private bool controlWasInitialize = false;
        private string UserProperty = "CustomProperty1";

        private void LoadCustomUserProperty(Outlook.MailItem MailItem)
        {
            laUserPropertyName.Text = UserProperty;
            Outlook.UserProperty customUserProperty = null;

            if (MailItem != null)
            {
                customUserProperty = MailItem.UserProperties.Find(UserProperty, true);

                if (customUserProperty == null)
                {
                    bool newEmail = (MailItem.Subject == null);
                    if (newEmail)
                    {
                        customUserProperty = MailItem.UserProperties.Add(UserProperty, Outlook.OlUserPropertyType.olText, true, Type.Missing);
                    }
                }

                if (customUserProperty != null)
                {
                    tbCustomUserProperty.Text = customUserProperty.Value.ToString();
                    tbCustomUserProperty.Enabled = true;
                    controlWasInitialize = true;
                }
                else
                {
                    //Get by MAPI
                    object mapiObject = MailItem.MAPIOBJECT;
                    string value = string.Empty;
                    try
                    {
                        value = MAPI.GetUserProperty(mapiObject, UserProperty);
                    }
                    finally
                    {
                        if (mapiObject != null)
                        {
                            Marshal.ReleaseComObject(mapiObject);
                            mapiObject = null;
                        }
                    }

                    if (value.Length > 0)
                    {
                        tbCustomUserProperty.Text = value + "*";
                        tbCustomUserProperty.Enabled = true;
                        controlWasInitialize = true;
                    }
                    else
                    {
                        tbCustomUserProperty.Text = string.Empty;
                        tbCustomUserProperty.Enabled = false;
                    }
                }
            }
        }

        private void InitializeUsedObjects()
        {
            if (MailItem != null)
            {
                LoadCustomUserProperty(MailItem);
            }
        }

        private void ClearUsedObjects()
        {
            if (_mailItem != null)
            {
                Marshal.ReleaseComObject(_mailItem);
                _mailItem = null;
            }
        }

        private void tbCustomUserProperty_TextChanged(object sender, EventArgs e)
        {
            if (controlWasInitialize)
            {
                if (InspectorObj != null)
                {
                    SaveCustomUserPropertyToItem();
                }
            }
        }

        private void ADXOlForm1_ADXBeforeFormShow()
        {
            InitializeUsedObjects();
        }

        private void ADXOlForm1_ADXBeforeInspectorSubpaneClose()
        {
            ClearUsedObjects();
        }

        private void ADXOlForm1_VisibleChanged(object sender, EventArgs e)
        {
            if (!this.Visible)
            {
                ClearUsedObjects();
            }
        }

    }
}

