using System;
using System.Runtime.InteropServices;

namespace UserPropertyInMail
{
    internal class MAPI
    {
        public const int S_OK = 0;

        public const uint PR_TRANSPORT_MESSAGE_HEADERS = 0x7D001E;
        public const uint PR_BODY = 0x1000001E;
        public const uint PR_BODY_HTML = 0x1013001E;
        public const uint PR_HTML = 0x10130102;

        public const uint MV_FLAG = 0x1000;

        public const uint PT_UNSPECIFIED = 0;
        public const uint PT_NULL = 1;
        public const uint PT_I2 = 2;
        public const uint PT_LONG = 3;
        public const uint PT_R4 = 4;
        public const uint PT_DOUBLE = 5;
        public const uint PT_CURRENCY = 6;
        public const uint PT_APPTIME = 7;
        public const uint PT_ERROR = 10;
        public const uint PT_BOOLEAN = 11;
        public const uint PT_OBJECT = 13;
        public const uint PT_I8 = 20;
        public const uint PT_STRING8 = 30;
        public const uint PT_UNICODE = 31;
        public const uint PT_SYSTIME = 64;
        public const uint PT_CLSID = 72;
        public const uint PT_BINARY = 258;
        public const uint PT_MV_TSTRING = (MV_FLAG | PT_STRING8);

        public const uint PR_SENDER_ADDRTYPE = (PT_STRING8 | (0x0C1E << 16));
        public const uint PR_SENDER_EMAIL_ADDRESS = (PT_STRING8 | (0x0C1F << 16));
        public const uint PR_SENDER_NAME = (PT_STRING8 | (0x0C1A << 16));
        public const uint PR_ADDRTYPE = (PT_STRING8 | (0x3002 << 16));
        public const uint PR_ADDRTYPE_W = (PT_UNICODE | (0x3002 << 16));
        public const uint PR_EMAIL_ADDRESS = (PT_STRING8 | (0x3003 << 16));
        public const uint PR_EMAIL_ADDRESS_W = (PT_UNICODE | (0x3003 << 16));
        public const uint PR_DISPLAY_NAME = (PT_STRING8 | (0x3001 << 16));
        public const uint PR_DISPLAY_NAME_W = (PT_UNICODE | (0x3001 << 16));
        public const uint PR_ENTRYID = (PT_BINARY | (0x0FFF << 16));
        public const uint PR_EMS_AB_PROXY_ADDRESSES = unchecked((uint)(PT_MV_TSTRING | (0x800F << 16)));
        public const uint PR_TRANSPORT_MESSAGE_HEADERS_A = (PT_STRING8 | (0x007D << 16));
        public const uint PR_TRANSPORT_MESSAGE_HEADERS_W = (PT_UNICODE | (0x007D << 16));


        public const uint MAPI_NEW_SESSION = 0x00000002;
        public const uint MAPI_FORCE_DOWNLOAD = 0x00001000;
        public const uint MAPI_LOGON_UI = 0x00000001;
        public const uint MAPI_ALLOW_OTHERS = 0x00000008;
        public const uint MAPI_EXPLICIT_PROFILE = 0x00000010;
        public const uint MAPI_EXTENDED = 0x00000020;
        public const uint MAPI_SERVICE_UI_ALWAYS = 0x00002000;
        public const uint MAPI_NO_MAIL = 0x00008000;
        public const uint MAPI_USE_DEFAULT = 0x00000040;

        public const uint AB_NO_DIALOG = 0x00000001;
        public const uint MAPI_DIALOG = 0x00000008;
        public const uint MAPI_UNICODE = 0x80000000;

        public const uint MAPI_CREATE = 0x00000002;

        public const uint MNID_STRING = 1;

        public const uint KEEP_OPEN_READONLY = 0x00000001;
        public const uint KEEP_OPEN_READWRITE = 0x00000002;
        public const uint FORCE_SAVE = 0x00000004;

        [DllImport("MAPI32.DLL", CharSet = CharSet.Ansi, EntryPoint = "HrGetOneProp@12")]
        public static extern int HrGetOneProp(IntPtr pmp, uint ulPropTag, out IntPtr ppProp);

        [DllImport("MAPI32.DLL", CharSet = CharSet.Ansi, EntryPoint = "MAPIFreeBuffer@4")]
        public static extern void MAPIFreeBuffer(IntPtr lpBuffer);


        public static string GetUserProperty(object mapiItemObj, string headerName)
        {

            IMAPIProp mail = null;
            string retVal = String.Empty;

            mail = mapiItemObj as IMAPIProp;
            if (mail != null)
            {
                IntPtr p = IntPtr.Zero;
                IntPtr lpszStr = IntPtr.Zero;
                IntPtr propTags = IntPtr.Zero;
                IntPtr lpszValue = IntPtr.Zero;
                IntPtr lpProblems = IntPtr.Zero;
                IntPtr lpPropValue = IntPtr.Zero;
                IntPtr _mapiNameID = IntPtr.Zero;
                IntPtr lpPropArray = IntPtr.Zero;
                //SPropValue propValue = new SPropValue();
                MAPINAMEID mapiNameID = new MAPINAMEID();
                try
                {
                    string UserPropertyGUID = "{00020329-0000-0000-C000-000000000046}";
                    Guid g = new Guid(UserPropertyGUID);
                    _mapiNameID = Marshal.AllocHGlobal(Marshal.SizeOf(typeof(MAPINAMEID)));

                    p = Marshal.AllocHGlobal(Marshal.SizeOf(g));
                    Marshal.StructureToPtr(g, p, false);
                    mapiNameID.lpguid = p;
                    mapiNameID.ulKind = MAPI.MNID_STRING;
                    lpszStr = Marshal.StringToHGlobalUni(headerName);
                    mapiNameID.lpwstrName = lpszStr;
                    Marshal.StructureToPtr(mapiNameID, _mapiNameID, false);

                    if (mail.GetIDsFromNames(1, ref _mapiNameID, MAPI.MAPI_CREATE, out propTags) == MAPI.S_OK)
                    {
                        int count = Marshal.ReadInt32(propTags);
                        if (count == 1)
                        {
                            uint cValues = 0;
                            if (mail.GetProps(propTags, MAPI.MAPI_UNICODE, out cValues, out lpPropArray) == MAPI.S_OK)
                            {
                                if (cValues == 1)
                                {
                                    uint pType = (uint)(Marshal.ReadInt32(lpPropArray) & 0xFFFF);
                                    if (pType == MAPI.PT_ERROR)
                                    {
                                        //Marshal.ThrowExceptionForHR(Marshal.ReadInt32(lpPropArray));
                                    }
                                    else
                                    {
                                        int strAddr = Marshal.ReadInt32(new IntPtr(lpPropArray.ToInt32() + 8));
                                        retVal = Marshal.PtrToStringAuto(new IntPtr(strAddr));
                                    }
                                }
                            }
                        }
                    }
                }
                finally
                {
                    if (lpPropArray != IntPtr.Zero)
                        MAPI.MAPIFreeBuffer(lpPropArray);
                    if (lpszValue != IntPtr.Zero)
                        Marshal.FreeHGlobal(lpszValue);
                    if (lpPropValue != IntPtr.Zero)
                        Marshal.DestroyStructure(lpPropValue, typeof(SPropValue));
                    if (propTags != IntPtr.Zero)
                        MAPI.MAPIFreeBuffer(propTags);
                    if (p != IntPtr.Zero)
                        Marshal.DestroyStructure(p, typeof(Guid));
                    if (lpszStr != IntPtr.Zero)
                        Marshal.FreeHGlobal(lpszStr);
                    if (_mapiNameID != IntPtr.Zero)
                        Marshal.DestroyStructure(_mapiNameID, typeof(MAPINAMEID));
                }
            }
            return retVal;
        }

    }

    [StructLayout(LayoutKind.Sequential)]
    public struct SPropValue
    {
        public uint ulPropTag;
        public uint dwAlignPad;
        public long Value;
    }

    [StructLayout(LayoutKind.Sequential)]
    public struct ADRENTRY
    {
        public uint ulReserved1;
        public uint cValues;
        public IntPtr rgPropVals;
    }

    [StructLayout(LayoutKind.Sequential)]
    public struct ADRLIST
    {
        public uint cEntries;
        public ADRENTRY aEntries;
    }

    [StructLayout(LayoutKind.Sequential)]
    public struct MAPINAMEID
    {
        public IntPtr lpguid;
        public uint ulKind;
        public IntPtr lpwstrName;
    }

    [
    ComImport, ComVisible(false),
    InterfaceType(ComInterfaceType.InterfaceIsIUnknown),
    Guid("00020303-0000-0000-C000-000000000046")
    ]
    public interface IMAPIProp
    {
        int GetLastError(int hResult, uint ulFlags, out IntPtr lppMAPIError);
        int SaveChanges(uint ulFlags);
        int GetProps(IntPtr lpPropTagArray, uint ulFlags, out uint lpcValues, out IntPtr lppPropArray);
        int GetPropList(uint ulFlags, out IntPtr lppPropTagArray);
        int OpenProperty(uint ulPropTag, ref Guid lpiid, uint ulInterfaceOptions, uint ulFlags, out IntPtr lppUnk);
        int SetProps(uint cValues, IntPtr lpPropArray, out IntPtr lppProblems);
        int DeleteProps(IntPtr lpPropTagArray, out IntPtr lppProblems);
        int CopyTo(uint ciidExclude, ref Guid rgiidExclude, IntPtr lpExcludeProps, uint ulUIParam,
            IntPtr lpProgress, ref Guid lpInterface, IntPtr lpDestObj, uint ulFlags, out IntPtr lppProblems);
        int CopyProps(IntPtr lpIncludeProps, uint ulUIParam, IntPtr lpProgress, ref Guid lpInterface,
            IntPtr lpDestObj, uint ulFlags, out IntPtr lppProblems);
        int GetNamesFromIDs(out IntPtr lppPropTags, ref Guid lpPropSetGuid, uint ulFlags,
            out uint lpcPropNames, out IntPtr lpppPropNames);
        int GetIDsFromNames(uint cPropNames, ref IntPtr lppPropNames, uint ulFlags, out IntPtr lppPropTags);
    }

}
